/*
 * Registry<Action>.hpp
 *
 *  Created on: Jan 7, 2010
 *      Author: crueger
 */

#ifndef ACTIONREGISTRY_HPP_
#define ACTIONREGISTRY_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif


#include <iosfwd>
#include <string>
#include <map>

#include "CodePatterns/Registry.hpp"
#include "CodePatterns/Singleton.hpp"
#include "Actions/Action.hpp"

namespace MoleCuilder {

/** Action Registry.
 *
 * The Action registry is a storage for any Action instance to retrieved by name.
 * It is a singleton and can be called from anywhere.
 *
 */
class ActionRegistry : public Singleton<ActionRegistry>, public Registry<Action>
{
  friend class Singleton<ActionRegistry>;
  //friend class Registry<Action>;

public:
  Action* getActionByName(const std::string name);
  bool isActionPresentByName(const std::string name) const;
  int getLastPosition(const std::string &MenuName) const;

private:
  ActionRegistry();
  ~ActionRegistry();

  void fillRegistry();
};

}

#endif /* ACTIONREGISTRY_HPP_ */
